var _jsxFileName = "/home/mirza/code/formbuilder/src/components/toolbar/field-forms/Content.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import ValidateField from "../../../utils/validations/ValidateField";
import Button from "@material-ui/core/Button";
import Select from '@material-ui/core/Select';
import FormControl from '@material-ui/core/FormControl';
import MenuItem from '@material-ui/core/MenuItem';
import Grid from '@material-ui/core/Grid';
import { disableFieldEdit as _disableFieldEdit } from "../../../actions/toolbarActions";
import { createField as _createField, deleteField as _deleteField, deleteNewField as _deleteNewField, updateField as _updateField, setAddLanguageSelect as _setAddLanguageSelect } from '../../../actions/formActions';
import { connect } from "react-redux";
import RichTextEditor from "../../../utils/rich-text-editor";
import { InputLabel } from "@material-ui/core";
import { Scrollbars } from 'react-custom-scrollbars';
import { getHeight } from '../../../utils/helpers';
import { processLocalFields } from './utils/helpers';
var addLangLabel = {
  en: 'Add Langauge',
  ar: 'إضافة لغة'
};
var selectLangLabel = {
  en: 'Select Language',
  ar: 'اختار اللغة'
};
var contentLabel = {
  en: 'Content',
  ar: 'المحتوى'
};
var contentArLabel = {
  en: 'Content in',
  ar: 'المحتوى في'
};
var cancelLabel = {
  en: 'Cancel',
  ar: 'إلغاء'
};
var saveLabel = {
  en: 'Save',
  ar: 'حفظ'
};

var Content = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Content, _React$Component);

  function Content(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleDataChange", function (val, name) {
      var _this$setState;

      _this.setState((_this$setState = {}, _this$setState[name] = val, _this$setState.errors = {}, _this$setState));
    });

    _defineProperty(_assertThisInitialized(_this), "saveField", function () {
      var _this$state = _this.state,
          name = _this$state.name,
          machineName = _this$state.machineName,
          order = _this$state.order,
          conditionalLogic = _this$state.conditionalLogic,
          subType = _this$state.subType,
          uuid = _this$state.uuid,
          type = _this$state.type,
          content = _this$state.content,
          visibility = _this$state.visibility,
          parentId = _this$state.parentId;
      var newField = {
        name: name,
        machineName: machineName,
        order: order,
        uuid: uuid,
        type: type,
        parentId: parentId,
        config: {
          conditionalLogic: conditionalLogic,
          subType: subType,
          content: content,
          visibility: visibility
        }
      };
      newField.locals = processLocalFields(_this.props.locals, _this.state);
      ValidateField(newField, null, _this.props.currentLang).then(function () {
        _this.props.updateField(newField);

        _this.props.disableFieldEdit();
      })["catch"](function (errors) {
        _this.setState({
          errors: errors
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "cancelEdit", function () {
      _this.props.deleteNewField();

      _this.props.disableFieldEdit();
    });

    _this.state = _extends({
      errors: {},
      uuid: props.data.uuid,
      name: props.data.name,
      type: props.data.type,
      order: props.data.order,
      parentId: props.data.parentId,
      machineName: props.data.machineName
    }, props.data.config);
    return _this;
  }

  var _proto = Content.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.props.setAddLanguageSelect({
      target: {
        value: ''
      }
    });
  };

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.data.uuid !== this.state.uuid) {
      this.setState(_extends({
        errors: {},
        uuid: nextProps.data.uuid,
        name: nextProps.data.name,
        type: nextProps.data.type,
        order: nextProps.data.order,
        parentId: nextProps.data.parentId,
        machineName: nextProps.data.machineName
      }, nextProps.data.config));
    }
  };

  _proto.render = function render() {
    var _this2 = this,
        _this$props$locals$fi;

    return /*#__PURE__*/React.createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 103,
        columnNumber: 7
      }
    }, /*#__PURE__*/React.createElement(Scrollbars, {
      style: {
        height: getHeight(true, false)
      },
      autoHide: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 104,
        columnNumber: 9
      }
    }, this.props.locals && this.props.locals.length !== 0 && /*#__PURE__*/React.createElement("div", {
      className: "ahfb-width-ful ahfb-px-3 ahfb-mt-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 106,
        columnNumber: 13
      }
    }, /*#__PURE__*/React.createElement(Grid, {
      container: true,
      spacing: 3,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 107,
        columnNumber: 15
      }
    }, /*#__PURE__*/React.createElement(Grid, {
      item: true,
      xs: 12,
      md: 3,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 108,
        columnNumber: 17
      }
    }, /*#__PURE__*/React.createElement("label", {
      className: "ahfb-mt-3 ahfb-align-center",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 109,
        columnNumber: 19
      }
    }, addLangLabel[this.props.currentLang])), /*#__PURE__*/React.createElement(Grid, {
      item: true,
      xs: 12,
      md: 9,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 111,
        columnNumber: 17
      }
    }, /*#__PURE__*/React.createElement(FormControl, {
      className: "ahfb-width-ful ahfb-d-flex",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 112,
        columnNumber: 19
      }
    }, /*#__PURE__*/React.createElement(InputLabel, {
      id: "demo-simple-select-label",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 113,
        columnNumber: 21
      }
    }, selectLangLabel[this.props.currentLang]), /*#__PURE__*/React.createElement(Select, {
      labelId: "demo-simple-select-label",
      id: "demo-simple-select",
      value: this.props.addLanguageSelect,
      onClick: this.props.setAddLanguageSelect,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 114,
        columnNumber: 21
      }
    }, this.props.locals.map(function (locale) {
      return /*#__PURE__*/React.createElement(MenuItem, {
        key: locale.key,
        value: locale.key,
        __self: _this2,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 121,
          columnNumber: 25
        }
      }, locale.name);
    })))))), /*#__PURE__*/React.createElement("div", {
      className: "ahfb-p-3 ahfb-my-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 129,
        columnNumber: 11
      }
    }, /*#__PURE__*/React.createElement(InputLabel, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 130,
        columnNumber: 13
      }
    }, contentLabel[this.props.currentLang]), /*#__PURE__*/React.createElement(RichTextEditor, {
      data: this.state.content,
      handleChange: function handleChange(data) {
        return _this2.handleDataChange(data, 'content');
      },
      error: this.state.errors.content,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 131,
        columnNumber: 13
      }
    }), this.props.addLanguageSelect ? /*#__PURE__*/React.createElement("div", {
      className: "ahfb-my-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 133,
        columnNumber: 15
      }
    }, /*#__PURE__*/React.createElement(InputLabel, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 134,
        columnNumber: 17
      }
    }, contentArLabel[this.props.currentLang], " ", (_this$props$locals$fi = this.props.locals.find(function (local) {
      return local.key === _this2.props.addLanguageSelect;
    })) == null ? void 0 : _this$props$locals$fi.name), /*#__PURE__*/React.createElement(RichTextEditor, {
      data: this.state.name_ar,
      handleChange: function handleChange(data) {
        return _this2.handleDataChange(data, "name_" + _this2.props.addLanguageSelect);
      },
      error: this.state.errors.content,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 135,
        columnNumber: 17
      }
    })) : '', /*#__PURE__*/React.createElement("div", {
      className: "ahfb-width-full ahfb-text-right ahfb-mt-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 140,
        columnNumber: 13
      }
    }, /*#__PURE__*/React.createElement(Button, {
      variant: "outlined",
      color: "primary",
      className: "ahfb-mr-2",
      onClick: this.cancelEdit,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 141,
        columnNumber: 15
      }
    }, cancelLabel[this.props.currentLang]), /*#__PURE__*/React.createElement(Button, {
      variant: "contained",
      color: "primary",
      disableElevation: true,
      onClick: this.saveField,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 144,
        columnNumber: 15
      }
    }, saveLabel[this.props.currentLang])))));
  };

  return Content;
}(React.Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    operation: state.toolbar.operation,
    locals: state.form.locals,
    addLanguageSelect: state.form.addLanguageSelect,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    disableFieldEdit: function disableFieldEdit() {
      return dispatch(_disableFieldEdit());
    },
    deleteNewField: function deleteNewField() {
      return dispatch(_deleteNewField());
    },
    createField: function createField(data) {
      return dispatch(_createField(data));
    },
    updateField: function updateField(data) {
      return dispatch(_updateField(data));
    },
    deleteField: function deleteField(id) {
      return dispatch(_deleteField(id));
    },
    setAddLanguageSelect: function setAddLanguageSelect(e) {
      return dispatch(_setAddLanguageSelect(e.target.value));
    }
  };
};

export default connect(mapStateToProps, mapDispatchToProps)(Content);