import { FIELD_TYPES } from '../../../../utils/Globals';
export var textFieldsConfigs = {
  isRequired: {
    type: FIELD_TYPES.CHECKBOX,
    configs: {
      label: {
        en: 'Required',
        ar: 'مطلوب'
      }
    }
  },
  name: {
    type: FIELD_TYPES.TEXT,
    isTranslatable: true,
    error: true,
    configs: {
      label: {
        en: 'Field Name',
        ar: 'اسم الحقل'
      },
      required: true,
      autoFocus: true
    }
  },
  subType: {
    type: FIELD_TYPES.SEARCHABLE_SELECT,
    configs: {
      label: {
        en: 'Field Type',
        ar: 'نوع الحقل'
      },
      options: [{
        label: {
          en: 'Text',
          ar: 'نص'
        },
        value: 'text'
      }, {
        label: {
          en: 'Number',
          ar: 'رقم'
        },
        value: 'number'
      }, {
        label: {
          en: 'Email',
          ar: 'البريد الإلكتروني'
        },
        value: 'email'
      }]
    }
  },
  helpText: {
    type: FIELD_TYPES.TEXT,
    isTranslatable: true,
    configs: {
      label: {
        en: 'Help Text',
        ar: 'نص المساعدة'
      }
    }
  },
  placeholder: {
    type: FIELD_TYPES.TEXT,
    isTranslatable: true,
    configs: {
      label: {
        en: 'Placeholder',
        ar: 'نائب'
      }
    }
  },
  maxLength: {
    type: FIELD_TYPES.TEXT,
    configs: {
      label: {
        en: 'Max Length',
        ar: 'الحد الاقصى للطول'
      },
      type: 'number'
    }
  },
  isRichText: {
    type: FIELD_TYPES.CHECKBOX,
    configs: {
      label: {
        en: 'Enable Rich Text Editor',
        ar: 'تمكين محرر النص المنسق'
      }
    }
  }
};