var _jsxFileName = "/home/mirza/code/formbuilder/src/index.js";

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import App from './components/app/App';
import { connect, Provider } from 'react-redux';
import { createMuiTheme } from '@material-ui/core/styles';
import { blue } from '@material-ui/core/colors';
import { applyMiddleware, createStore } from 'redux';
import rootReducer from './reducers/rootReducer';
import thunk from 'redux-thunk';
import CircularProgress from '@material-ui/core/CircularProgress';
import './styles/index.scss';
var theme = createMuiTheme({
  palette: {
    primary: {
      main: blue[700]
    }
  }
});

var FormBuilder = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(FormBuilder, _React$Component);

  function FormBuilder(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "initializeSubmit", function () {
      _this.child.current.submitForm();
    });

    _this.child = React.createRef();
    _this.state = {
      loading: true
    };
    return _this;
  }

  var _proto = FormBuilder.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    setTimeout(function () {
      _this2.setState({
        loading: false
      });
    }, 1000);
  };

  _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState, nextContext) {
    return this.state.loading;
  };

  _proto.render = function render() {
    var _this3 = this;

    if (this.state.loading) {
      return /*#__PURE__*/React.createElement("div", {
        className: "ahfb-width-full ahfb-text-center ahfb-pt-5 ahfb-pb-5",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 48,
          columnNumber: 9
        }
      }, /*#__PURE__*/React.createElement(CircularProgress, {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 49,
          columnNumber: 11
        }
      }));
    }

    return /*#__PURE__*/React.createElement(Provider, {
      store: createStore(rootReducer, applyMiddleware(thunk)),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 54,
        columnNumber: 7
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: "ahfb-width-full",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 58,
        columnNumber: 9
      }
    }, /*#__PURE__*/React.createElement(App, {
      locals: this.props.locals,
      theme: this.props.theme,
      initializeSubmit: function initializeSubmit(click) {
        return _this3.initializeSubmit = click;
      },
      currentLang: this.props.currentLang,
      onSubmit: this.props.onSubmit,
      formData: this.props.data,
      predefinedEndpoint: this.props.predefinedEndpoint,
      fileUploadUrl: this.props.fileUploadUrl,
      conditionableFields: this.props.conditionableFields,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 59,
        columnNumber: 11
      }
    })));
  };

  return FormBuilder;
}(React.Component);

FormBuilder.defaultProps = {
  // data: {
  //   "5e455c88-e060-4f16-b2f9-1aaffbe8a87c": {
  //     "name": "First Name",
  //     "machineName": "first_name",
  //     "order": 1,
  //     "uuid": "5e455c88-e060-4f16-b2f9-1aaffbe8a87c",
  //     "type": "text",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "isRichText": false,
  //       "maxLength": null,
  //       "placeholder": null,
  //       "helpText": null,
  //       "subType": "text",
  //       "regex": null,
  //       "visibility": true
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "الإسم الأوّل"
  //       }
  //     }
  //   },
  //   "473cc6d2-38fe-4525-8495-4e13a630f8af": {
  //     "name": "Last Name",
  //     "machineName": "last_name",
  //     "order": 2,
  //     "uuid": "473cc6d2-38fe-4525-8495-4e13a630f8af",
  //     "type": "text",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "isRichText": false,
  //       "maxLength": null,
  //       "placeholder": null,
  //       "helpText": null,
  //       "subType": "text",
  //       "regex": null,
  //       "visibility": true
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "إسم العائلة"
  //       }
  //     }
  //   },
  //   "7533c815-6827-490c-800b-4d61c9936fb8": {
  //     "name": "Offer Letter",
  //     "machineName": "file-1651145479",
  //     "order": 4,
  //     "uuid": "7533c815-6827-490c-800b-4d61c9936fb8",
  //     "type": "file",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "placeholder": "Drag and drop files here",
  //       "helpText": null,
  //       "subType": "file",
  //       "visibility": true,
  //       "isMultiple": false,
  //       "supportedFiles": []
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "العرض الوظيفي"
  //       }
  //     }
  //   },
  //   "7461c609-5bb0-46cf-9ecd-ef6579458187": {
  //     "name": "Signature Date",
  //     "machineName": "date-1651145512",
  //     "order": 5,
  //     "uuid": "7461c609-5bb0-46cf-9ecd-ef6579458187",
  //     "type": "date",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "helpText": null,
  //       "subType": "date",
  //       "visibility": true,
  //       "shouldDateValidate": false,
  //       "dateValidations": {
  //         "pastUnit": "days",
  //         "pastMax": 0,
  //         "pastMin": 0,
  //         "futureUnit": "days",
  //         "futureMax": 0,
  //         "futureMin": 0
  //       },
  //       "selectedDate": {
  //         "afterSelect": "After Selected Date",
  //       }
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "تاريخ التوقيع"
  //       }
  //     }
  //   },
  //   "7621fefc-e85a-4c50-842d-35a3fd996151": {
  //     "name": "Signature",
  //     "machineName": "signature-1651145538",
  //     "order": 6,
  //     "uuid": "7621fefc-e85a-4c50-842d-35a3fd996151",
  //     "type": "signature",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "helpText": null,
  //       "subType": "signature",
  //       "visibility": true
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "التوقيع"
  //       }
  //     }
  //   },
  //   "05bcc604-eaa0-4f3f-9e7d-b312633ae8ee": {
  //     "name": "Contract Upload",
  //     "machineName": "file-1651145972",
  //     "order": 7,
  //     "uuid": "05bcc604-eaa0-4f3f-9e7d-b312633ae8ee",
  //     "type": "file",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "placeholder": "Drag and drop files here",
  //       "helpText": null,
  //       "subType": "file",
  //       "visibility": true,
  //       "isMultiple": false,
  //       "supportedFiles": []
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "تحميل العقد"
  //       }
  //     }
  //   },
  //   "0e6e4f91-cf03-4766-8687-c364cb7feaaa": {
  //     "name": "Was the New Hire Profile created on HRIS (SAP)?",
  //     "machineName": "radio-1651145889",
  //     "order": 8,
  //     "uuid": "0e6e4f91-cf03-4766-8687-c364cb7feaaa",
  //     "type": "radio",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "helpText": null,
  //       "subType": "radio",
  //       "visibility": true,
  //       "optionReferenceId": 72,
  //       "enableOther": false
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "هل تم إنشاء ملف تعريف الموظف الجديد على نظام معلومات الموارد البشرية (SAP)؟"
  //       }
  //     }
  //   },
  //   "c4b71341-694d-4238-a8d9-af4fe93e5a07": {
  //     "name": "Assigned Laptop Serial Number",
  //     "machineName": "text-1651146130",
  //     "order": 11,
  //     "uuid": "c4b71341-694d-4238-a8d9-af4fe93e5a07",
  //     "type": "text",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": [
  //           {
  //             "field": "radio-1651146064",
  //             "operator": "is",
  //             "value": 1797
  //           }
  //         ]
  //       },
  //       "isConditionalEnabled": true,
  //       "isRequired": true,
  //       "isRichText": false,
  //       "maxLength": null,
  //       "placeholder": null,
  //       "helpText": null,
  //       "subType": "text",
  //       "regex": null,
  //       "visibility": true
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "الرقم التسلسلي المخصص للكمبيوتر المحمول"
  //       }
  //     }
  //   },
  //   "41e3e48a-94ce-454a-bb69-8715e8a603ed": {
  //     "name": "Assigned Monitor Serial Number",
  //     "machineName": "text-1651146210",
  //     "order": 12,
  //     "uuid": "41e3e48a-94ce-454a-bb69-8715e8a603ed",
  //     "type": "text",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": [
  //           {
  //             "field": "radio-1651146064",
  //             "operator": "is",
  //             "value": 1798
  //           }
  //         ]
  //       },
  //       "isConditionalEnabled": true,
  //       "isRequired": true,
  //       "isRichText": false,
  //       "maxLength": null,
  //       "placeholder": null,
  //       "helpText": null,
  //       "subType": "text",
  //       "regex": null,
  //       "visibility": true
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "الرقم التسلسلي المخصص للشاشة"
  //       }
  //     }
  //   },
  //   "92f5ea5f-c156-4918-ab48-2997f925e539": {
  //     "name": "Assigned Mouse Serial Number",
  //     "machineName": "text-1651146250",
  //     "order": 13,
  //     "uuid": "92f5ea5f-c156-4918-ab48-2997f925e539",
  //     "type": "text",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": [
  //           {
  //             "field": "radio-1651146064",
  //             "operator": "is",
  //             "value": 1799
  //           }
  //         ]
  //       },
  //       "isConditionalEnabled": true,
  //       "isRequired": true,
  //       "isRichText": false,
  //       "maxLength": null,
  //       "placeholder": null,
  //       "helpText": null,
  //       "subType": "text",
  //       "regex": null,
  //       "visibility": true
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "الرقم التسلسلي المخصص للماوس"
  //       }
  //     }
  //   },
  //   "a057a76d-65d3-47ef-8a9f-3eee14388b0f": {
  //     "name": "Assigned Headphones Serial Number",
  //     "machineName": "text-1651146283",
  //     "order": 14,
  //     "uuid": "a057a76d-65d3-47ef-8a9f-3eee14388b0f",
  //     "type": "text",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": [
  //           {
  //             "field": "radio-1651146064",
  //             "operator": "is",
  //             "value": 1800
  //           }
  //         ]
  //       },
  //       "isConditionalEnabled": true,
  //       "isRequired": true,
  //       "isRichText": false,
  //       "maxLength": null,
  //       "placeholder": null,
  //       "helpText": null,
  //       "subType": "text",
  //       "regex": null,
  //       "visibility": true
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "الرقم التسلسلي المخصص لسماعات الرأس"
  //       }
  //     }
  //   },
  //   "fd1bf416-e2e1-4489-95f0-ee4c84efb106": {
  //     "name": "Has an office been allocated?",
  //     "machineName": "radio-1651146391",
  //     "order": 15,
  //     "uuid": "fd1bf416-e2e1-4489-95f0-ee4c84efb106",
  //     "type": "radio",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "helpText": null,
  //       "subType": "radio",
  //       "visibility": true,
  //       "optionReferenceId": 74,
  //       "enableOther": false
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "هل تم تخصيص مكتب؟"
  //       }
  //     }
  //   },
  //   "f7d308b5-b6fb-4172-aae8-fefd91b1d5c3": {
  //     "name": "Office Allocation",
  //     "machineName": "text-1651146434",
  //     "order": 16,
  //     "uuid": "f7d308b5-b6fb-4172-aae8-fefd91b1d5c3",
  //     "type": "text",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": [
  //           {
  //             "field": "radio-1651146391",
  //             "operator": "is",
  //             "value": 1801
  //           }
  //         ]
  //       },
  //       "isConditionalEnabled": true,
  //       "isRequired": true,
  //       "isRichText": false,
  //       "maxLength": null,
  //       "placeholder": null,
  //       "helpText": null,
  //       "subType": "text",
  //       "regex": null,
  //       "visibility": true
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "المكتب المخصّص"
  //       }
  //     }
  //   },
  //   "c07cc059-2fe4-4e09-a59c-06a82b999a0b": {
  //     "name": "Is an Airline Ticket Needed?",
  //     "machineName": "radio-1651146500",
  //     "order": 17,
  //     "uuid": "c07cc059-2fe4-4e09-a59c-06a82b999a0b",
  //     "type": "radio",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "helpText": null,
  //       "subType": "radio",
  //       "visibility": true,
  //       "optionReferenceId": 75,
  //       "enableOther": false
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "هل هناك حاجة إلى تذكرة طيران؟"
  //       }
  //     }
  //   },
  //   "8fe7e29f-b25a-461a-b965-5966498a2b5b": {
  //     "name": "Upload Airline Ticket",
  //     "machineName": "file-1651146548",
  //     "order": 18,
  //     "uuid": "8fe7e29f-b25a-461a-b965-5966498a2b5b",
  //     "type": "file",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "placeholder": "Drag and drop files here",
  //       "helpText": null,
  //       "subType": "file",
  //       "visibility": true,
  //       "isMultiple": false,
  //       "supportedFiles": []
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "تحميل تذكرة طيران"
  //       }
  //     }
  //   },
  //   "2049f615-05e1-4187-8bff-f0949c7cb2e3": {
  //     "name": "Is ground transportation needed?",
  //     "machineName": "radio-1651146592",
  //     "order": 19,
  //     "uuid": "2049f615-05e1-4187-8bff-f0949c7cb2e3",
  //     "type": "radio",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "helpText": null,
  //       "subType": "radio",
  //       "visibility": true,
  //       "optionReferenceId": 75,
  //       "enableOther": false
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "هل النقل البري مطلوب؟"
  //       }
  //     }
  //   },
  //   "5a4f7cf3-dc1a-4a5d-bab8-9ad5f65eefa1": {
  //     "name": "Joining Date",
  //     "machineName": "joining_date",
  //     "order": 3,
  //     "uuid": "5a4f7cf3-dc1a-4a5d-bab8-9ad5f65eefa1",
  //     "type": "date",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "helpText": null,
  //       "subType": "date",
  //       "visibility": true,
  //       "shouldDateValidate": false,
  //       "dateValidations": {
  //         "pastUnit": "days",
  //         "pastMax": 0,
  //         "pastMin": 0,
  //         "futureUnit": "days",
  //         "futureMax": 0,
  //         "futureMin": 0
  //       }
  //     },
  //     "locals": {
  //       "ar": {
  //         "name_ar": "تاريخ الانضمام"
  //       }
  //     }
  //   },
  //   "1bc0ceaf-e7df-4748-a9cd-6c7332fb4fcc": {
  //     "name": "Assigned Hardware",
  //     "machineName": "checkbox-1652085089",
  //     "order": 9,
  //     "uuid": "1bc0ceaf-e7df-4748-a9cd-6c7332fb4fcc",
  //     "type": "checkbox",
  //     "parentId": 0,
  //     "config": {
  //       "conditionalLogic": {
  //         "display": "show",
  //         "logic": "all",
  //         "conditions": []
  //       },
  //       "isConditionalEnabled": false,
  //       "isRequired": true,
  //       "helpText": null,
  //       "subType": "checkbox",
  //       "visibility": true,
  //       "optionReferenceId": 77,
  //       "enableOther": false
  //     },
  //     "locals": []
  //   }
  // },
  data: {
    "95ee05a6-5b93-4d3b-a7cb-b017b70c247c": {
      "name": "Father's Name",
      "machineName": "text-1646296994",
      "order": 1,
      "uuid": "95ee05a6-5b93-4d3b-a7cb-b017b70c247c",
      "type": "text",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": false,
        "isRichText": false,
        "maxLength": null,
        "placeholder": "test placeholder",
        "helpText": "father name test",
        "subType": "text",
        "regex": null,
        "visibility": true
      },
      "locals": []
    },
    "c2ae05fd-5eb6-4da9-9bd3-dd4db6ae44c2": {
      "name": "Upload Photograph (white background)",
      "machineName": "file-1646297011",
      "order": 3,
      "uuid": "c2ae05fd-5eb6-4da9-9bd3-dd4db6ae44c2",
      "type": "file",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": false,
        "placeholder": "Drag and drop files here",
        "helpText": "upload photo test",
        "subType": "file",
        "visibility": true,
        "isMultiple": false,
        "supportedFiles": []
      },
      "locals": []
    },
    "0f9c02e1-7634-4271-98a4-1332723ba933": {
      "name": "Upload Passport Copy",
      "machineName": "file-1646297019",
      "order": 4,
      "uuid": "0f9c02e1-7634-4271-98a4-1332723ba933",
      "type": "file",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": false,
        "placeholder": "Drag and drop files here",
        "helpText": "upload passport image test",
        "subType": "file",
        "visibility": true,
        "isMultiple": false,
        "supportedFiles": []
      },
      "locals": []
    },
    "854e0b9d-aba7-4a97-86d5-ed673979af48": {
      "name": "Employee ID | هوية الموظف",
      "machineName": "text-1646297052",
      "order": 2,
      "uuid": "854e0b9d-aba7-4a97-86d5-ed673979af48",
      "type": "text",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": false,
        "isRichText": false,
        "maxLength": null,
        "placeholder": null,
        "helpText": "employee id test",
        "subType": "text",
        "regex": null,
        "visibility": true
      },
      "locals": []
    },
    "8f51706c-ec92-4276-b762-e4ac42406c71": {
      "name": "Laptop ID (S/N)",
      "machineName": "text-1646297135",
      "order": 7,
      "uuid": "8f51706c-ec92-4276-b762-e4ac42406c71",
      "type": "text",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": false,
        "isRichText": false,
        "maxLength": null,
        "placeholder": null,
        "helpText": null,
        "subType": "text",
        "regex": null,
        "visibility": true
      },
      "locals": []
    },
    "6d9a44f9-72e9-4b11-810c-3e3239fb84de": {
      "name": "Access Card",
      "machineName": "file-1646297160",
      "order": 8,
      "uuid": "6d9a44f9-72e9-4b11-810c-3e3239fb84de",
      "type": "file",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": false,
        "placeholder": "Drag and drop files here",
        "helpText": null,
        "subType": "file",
        "visibility": true,
        "isMultiple": false,
        "supportedFiles": []
      },
      "locals": []
    },
    "5c3ed563-1df5-489c-9b97-e656d637f78a": {
      "name": "Laptop Preference",
      "machineName": "select-1646300390",
      "uuid": "5c3ed563-1df5-489c-9b97-e656d637f78a",
      "type": "select",
      "order": 5,
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": false,
        "placeholder": null,
        "helpText": "test laptop",
        "subType": "select",
        "visibility": true,
        "isMultiple": false,
        "optionReferenceId": 79,
        "enableOther": false
      },
      "locals": []
    },
    "e680a7e1-6f87-4c75-b344-eadd87f303da": {
      "name": "Visa Expiry",
      "machineName": "date-1658913500",
      "order": 9,
      "uuid": "e680a7e1-6f87-4c75-b344-eadd87f303da",
      "type": "date",
      "parentId": 0,
      "isReminder": 1,
      "config": {
        "reminderLogic": {
          "template_html": "this will be html",
          "quantity": 5,
          "type": "days",
          "conditions": "before"
        },
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": false,
        "helpText": null,
        "subType": "date",
        "visibility": true,
        "shouldDateValidate": false,
        "dateValidations": {
          "pastUnit": "days",
          "pastMax": 0,
          "pastMin": 0,
          "futureUnit": "days",
          "futureMax": 0,
          "futureMin": 0
        }
      },
      "locals": []
    }
  },
  conditionableFields: [{
    "id": 1,
    "form_id": 1,
    "type": "text",
    "name": "First Name as per Passport",
    "machine_name": "first_name",
    "order": 1,
    "created_at": "2021-05-03 09:04:08",
    "updated_at": "2022-02-03 12:34:30",
    "is_master": true,
    "is_mapped": true,
    "uuid": "38c347d1-2bba-4703-bd78-626c80701500",
    "config": {
      "regex": null,
      "subType": "text",
      "helpText": null,
      "maxLength": null,
      "isRequired": 1,
      "isRichText": false,
      "visibility": true,
      "placeholder": "First Name",
      "conditionalLogic": {
        "logic": "all",
        "display": "show",
        "conditions": []
      },
      "isConditionalEnabled": false
    },
    "options_reference_id": null,
    "parent_id": null,
    "locals": {
      "ar": {
        "name_ar": "الاسم الأول حسب جواز السفر"
      }
    },
    "is_reminder": 0
  }, {
    "id": 2,
    "form_id": 1,
    "type": "text",
    "name": "Last name as per passport",
    "machine_name": "last_name",
    "order": 2,
    "created_at": "2021-05-03 09:04:08",
    "updated_at": "2022-02-03 12:34:30",
    "is_master": true,
    "is_mapped": true,
    "uuid": "4e958695-aee6-41f6-bc8b-c784fdcb2cfe",
    "config": {
      "regex": null,
      "subType": "text",
      "helpText": null,
      "maxLength": null,
      "isRequired": 1,
      "isRichText": false,
      "visibility": true,
      "placeholder": "Last Name",
      "conditionalLogic": {
        "logic": "all",
        "display": "show",
        "conditions": []
      },
      "isConditionalEnabled": false
    },
    "options_reference_id": null,
    "parent_id": null,
    "locals": {
      "ar": {
        "name_ar": "الاسم الأخير حسب جواز السفر"
      }
    },
    "is_reminder": 0
  }, {
    "id": 3,
    "form_id": 1,
    "type": "text",
    "name": "Work Email",
    "machine_name": "work_email",
    "order": 7,
    "created_at": "2021-05-03 09:04:08",
    "updated_at": "2022-02-03 12:34:30",
    "is_master": true,
    "is_mapped": false,
    "uuid": "49d5a184-95d3-45ed-8739-313da7a58e97",
    "config": {
      "regex": null,
      "subType": "email",
      "helpText": null,
      "maxLength": null,
      "isRequired": 0,
      "isRichText": false,
      "visibility": true,
      "placeholder": "Work Email",
      "conditionalLogic": {
        "logic": "all",
        "display": "show",
        "conditions": []
      },
      "isConditionalEnabled": false
    },
    "options_reference_id": null,
    "parent_id": null,
    "locals": {
      "ar": {
        "name_ar": "البريد الإلكتروني العمل"
      }
    },
    "is_reminder": 0
  }, {
    "id": 4,
    "form_id": 1,
    "type": "text",
    "name": "Personal Email",
    "machine_name": "personal_email",
    "order": 8,
    "created_at": "2021-05-03 09:04:08",
    "updated_at": "2022-02-03 12:34:30",
    "is_master": true,
    "is_mapped": true,
    "uuid": "660c81af-fe42-4def-bb61-eabc789c1f8d",
    "config": {
      "regex": null,
      "subType": "email",
      "helpText": null,
      "maxLength": null,
      "isRequired": 0,
      "isRichText": false,
      "visibility": true,
      "placeholder": "Personal Email",
      "conditionalLogic": {
        "logic": "all",
        "display": "show",
        "conditions": []
      },
      "isConditionalEnabled": false
    },
    "options_reference_id": null,
    "parent_id": null,
    "locals": {
      "ar": {
        "name_ar": "البريد الإلكتروني الشخصي"
      }
    },
    "is_reminder": 0
  }, {
    "id": 5,
    "form_id": 1,
    "type": "date",
    "name": "Expected date of Joining",
    "machine_name": "joining_date",
    "order": 9,
    "created_at": "2021-05-03 09:04:08",
    "updated_at": "2022-02-03 12:34:30",
    "is_master": true,
    "is_mapped": true,
    "uuid": "aa014e8c-3151-4660-b3ea-265a938c5cc6",
    "config": {
      "subType": "date",
      "helpText": null,
      "isRequired": 0,
      "visibility": true,
      "dateValidations": {
        "pastMax": 0,
        "pastMin": 0,
        "pastUnit": "days",
        "futureMax": 0,
        "futureMin": 0,
        "futureUnit": "days"
      },
      "conditionalLogic": {
        "logic": "all",
        "display": "show",
        "conditions": []
      },
      "shouldDateValidate": false,
      "isConditionalEnabled": false
    },
    "options_reference_id": null,
    "parent_id": null,
    "locals": {
      "ar": {
        "name_ar": "التاريخ المتوقع للانضمام"
      }
    },
    "is_reminder": 0
  }, {
    "id": 6,
    "form_id": 1,
    "type": "text",
    "name": "Mobile Phone",
    "machine_name": "mobile_phone",
    "order": 3,
    "created_at": "2021-05-03 09:04:08",
    "updated_at": "2022-02-03 12:34:30",
    "is_master": true,
    "is_mapped": true,
    "uuid": "644b3684-2165-48a5-9e21-f43106e73115",
    "config": {
      "regex": null,
      "subType": "number",
      "helpText": null,
      "maxLength": null,
      "isRequired": 0,
      "isRichText": false,
      "visibility": true,
      "placeholder": "Mobile Phone",
      "conditionalLogic": {
        "logic": "all",
        "display": "show",
        "conditions": []
      },
      "isConditionalEnabled": false
    },
    "options_reference_id": null,
    "parent_id": null,
    "locals": {
      "ar": {
        "name_ar": "تليفون محمول"
      }
    },
    "is_reminder": 0
  }, {
    "id": 7,
    "form_id": 1,
    "type": "select",
    "name": "Actual work Location",
    "machine_name": "location",
    "order": 4,
    "created_at": "2021-05-03 09:04:08",
    "updated_at": "2022-02-03 12:34:30",
    "is_master": true,
    "is_mapped": true,
    "uuid": "12be68b4-decb-4c3e-8e3c-580cf72385a5",
    "config": {
      "subType": "select",
      "helpText": null,
      "isMultiple": 0,
      "isRequired": 1,
      "visibility": true,
      "enableOther": false,
      "placeholder": "Location",
      "conditionalLogic": {
        "logic": "all",
        "display": "show",
        "conditions": []
      },
      "optionReferenceId": 7,
      "isConditionalEnabled": false
    },
    "options_reference_id": 7,
    "parent_id": null,
    "locals": {
      "ar": {
        "name_ar": "موقع العمل الفعلي"
      }
    },
    "is_reminder": 0
  }, {
    "id": 8,
    "form_id": 1,
    "type": "select",
    "name": "Actual Job Title",
    "machine_name": "job_title",
    "order": 6,
    "created_at": "2021-05-03 09:04:08",
    "updated_at": "2022-02-03 12:34:30",
    "is_master": true,
    "is_mapped": true,
    "uuid": "90a87af9-de40-4841-9d6f-63c98d67e54b",
    "config": {
      "subType": "select",
      "helpText": null,
      "isMultiple": 0,
      "isRequired": 0,
      "visibility": true,
      "enableOther": false,
      "placeholder": "Job Title",
      "conditionalLogic": {
        "logic": "all",
        "display": "show",
        "conditions": []
      },
      "optionReferenceId": 5,
      "isConditionalEnabled": false
    },
    "options_reference_id": 5,
    "parent_id": null,
    "locals": {
      "ar": {
        "name_ar": "المسمى الوظيفي الفعلي"
      }
    },
    "is_reminder": 0
  }, {
    "id": 9,
    "form_id": 1,
    "type": "select",
    "name": "Group",
    "machine_name": "division",
    "order": 5,
    "created_at": "2021-05-03 09:04:08",
    "updated_at": "2022-02-03 12:34:30",
    "is_master": true,
    "is_mapped": true,
    "uuid": "fd9b9ad0-1826-4396-b558-03dc262f9a60",
    "config": {
      "subType": "select",
      "helpText": null,
      "isMultiple": 0,
      "isRequired": 1,
      "visibility": true,
      "enableOther": false,
      "placeholder": "Division",
      "conditionalLogic": {
        "logic": "all",
        "display": "show",
        "conditions": []
      },
      "optionReferenceId": 6,
      "isConditionalEnabled": false
    },
    "options_reference_id": 6,
    "parent_id": null,
    "locals": {
      "ar": {
        "name_ar": "مجموعة"
      }
    },
    "is_reminder": 0
  }, {
    "id": 180,
    "form_id": 1,
    "type": "select",
    "name": "Hiring Manager",
    "machine_name": "hiring_manager",
    "order": 9,
    "created_at": "2021-05-03 09:04:08",
    "updated_at": "2022-02-03 12:34:30",
    "is_master": true,
    "is_mapped": false,
    "uuid": "aa90982b-4664-4ee6-a338-7cd148665a74",
    "config": {
      "subType": "select",
      "helpText": null,
      "isMultiple": 0,
      "isRequired": 0,
      "visibility": true,
      "enableOther": false,
      "placeholder": "Hiring Manager",
      "conditionalLogic": {
        "logic": "all",
        "display": "show",
        "conditions": []
      },
      "optionReferenceId": null,
      "isConditionalEnabled": false
    },
    "options_reference_id": null,
    "parent_id": null,
    "locals": {
      "ar": {
        "name_ar": "مدير التوظيف"
      }
    },
    "is_reminder": 0
  }],
  theme: {
    direction: 'ltr'
  },
  currentLang: 'en',
  locals: [{
    key: 'ar',
    name: 'Arabic'
  }, {
    key: 'ru',
    name: 'Russian'
  }]
};
export default FormBuilder;