var _jsxFileName = "/home/mirza/code/formbuilder/src/utils/predefined-values/NewCategory.js";
import React from 'react';
import TextInput from "../inputs/TextInput";
import IconButton from "@material-ui/core/IconButton";
import DoneIcon from "@material-ui/icons/Done";
import CloseIcon from "@material-ui/icons/Close";
var sameNameError = {
  en: 'Category with same name already exists.',
  ar: 'الفئة التي تحمل نفس الاسم موجودة بالفعل.'
};
var nameRequiredError = {
  en: 'Category name is required.',
  ar: 'مطلوب اسم الفئة'
};
var placeholderLabel = {
  en: 'Category Name',
  ar: 'اسم التصنيف'
};
export default function NewCategory(props) {
  var _React$useState = React.useState(''),
      value = _React$useState[0],
      setValue = _React$useState[1];

  var _React$useState2 = React.useState(''),
      error = _React$useState2[0],
      setError = _React$useState2[1];

  var handleChange = function handleChange(e) {
    setError('');
    setValue(e.target.value);
  };

  var saveNewCategory = function saveNewCategory() {
    if (props.names.includes(value.toLocaleLowerCase())) {
      setError(sameNameError[props.currentLang]);
    } else if (!value.length) {
      setError(nameRequiredError[props.currentLang]);
    } else {
      props.saveNewCategory(value);
    }
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "ahfb-pl-3",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 40,
      columnNumber: 5
    }
  }, /*#__PURE__*/React.createElement(TextInput, {
    placeholder: placeholderLabel[props.currentLang],
    value: value,
    handleChange: handleChange,
    autoFocus: true,
    error: error,
    endAdornment: /*#__PURE__*/React.createElement(React.Fragment, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 48,
        columnNumber: 11
      }
    }, /*#__PURE__*/React.createElement(IconButton, {
      size: "small",
      onClick: saveNewCategory,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 49,
        columnNumber: 13
      }
    }, /*#__PURE__*/React.createElement(DoneIcon, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 49,
        columnNumber: 64
      }
    })), /*#__PURE__*/React.createElement(IconButton, {
      size: "small",
      onClick: props.handleAddCategoryClose,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 50,
        columnNumber: 13
      }
    }, /*#__PURE__*/React.createElement(CloseIcon, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 50,
        columnNumber: 77
      }
    }))),
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 41,
      columnNumber: 7
    }
  }));
}