"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _formActions = require("../../actions/formActions");

var _toolbarActions = require("../../actions/toolbarActions");

var _reactRedux = require("react-redux");

var _Input = _interopRequireDefault(require("./fields-wrappers/Input"));

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

var _FileCopy = _interopRequireDefault(require("@material-ui/icons/FileCopy"));

var _Edit = _interopRequireDefault(require("@material-ui/icons/Edit"));

var _core = require("@material-ui/core");

var _Select = _interopRequireDefault(require("./fields-wrappers/Select"));

var _ButtonGroup = _interopRequireDefault(require("@material-ui/core/ButtonGroup"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Checkbox = _interopRequireDefault(require("./fields-wrappers/Checkbox"));

var _Radio = _interopRequireDefault(require("./fields-wrappers/Radio"));

var _Date = _interopRequireDefault(require("./fields-wrappers/Date"));

var _Content = _interopRequireDefault(require("./fields-wrappers/Content"));

var _File = _interopRequireDefault(require("./fields-wrappers/File"));

var _Section = _interopRequireDefault(require("./fields-wrappers/Section"));

var _Signature = _interopRequireDefault(require("./fields-wrappers/Signature"));

var _Image = _interopRequireDefault(require("./fields-wrappers/Image"));

var _Video = _interopRequireDefault(require("./fields-wrappers/Video"));

var _helpers = require("../../utils/helpers");

var _useWindowSize2 = require("../hooks/useWindowSize");

var _lodash = _interopRequireDefault(require("lodash"));

var _axios = _interopRequireDefault(require("axios"));

var _predefinedActions = require("../../actions/predefinedActions");

var _jsxFileName = "/home/mirza/code/formbuilder/src/components/app/FieldWrapper.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function FieldWrapper(props) {
  var _this = this;

  var _React$useState = _react["default"].useState(false),
      options = _React$useState[0],
      setOptions = _React$useState[1];

  var _useWindowSize = (0, _useWindowSize2.useWindowSize)(),
      width = _useWindowSize.width;

  var enableEdit = function enableEdit(e) {
    props.enableFieldEdit(props.data.uuid);
  };

  var removeField = function removeField(e) {
    if (props.editId === props.data.uuid) {
      props.disableFieldEdit();
    }

    props.deleteField(props.data.uuid);
  };

  var cloneField = function cloneField(e) {
    var _newData$config;

    var uuid = (0, _helpers.generateUUID)();
    var machineName = props.data.type + "-" + (0, _helpers.getUniqueNumber)();

    var newData = _lodash["default"].cloneDeep(props.data);

    newData.uuid = uuid;
    newData.machineName = machineName;

    if (["checkbox", "select", "radio"].includes(newData == null ? void 0 : newData.type) && (newData == null ? void 0 : (_newData$config = newData.config) == null ? void 0 : _newData$config.optionReferenceId)) {
      var preDef = props.predefined.find(function (item) {
        var _newData$config2;

        return item.id === (newData == null ? void 0 : (_newData$config2 = newData.config) == null ? void 0 : _newData$config2.optionReferenceId);
      });
      var clonePredef = {
        id: (0, _helpers.getUniqueNumber)(),
        name: preDef.name + '_clone_' + (0, _helpers.getUniqueNumber)(),
        slug: preDef.slug + '_clone_' + (0, _helpers.getUniqueNumber)(),
        is_public: false,
        is_secure: false,
        isNew: true,
        options: preDef.options.map(function (item) {
          return _extends({}, item, {
            id: (0, _helpers.getUniqueNumber)()
          });
        })
      };
      props.addCategory(clonePredef);
      newData.config = _extends({}, newData.config, {
        optionReferenceId: clonePredef.id
      });
      props.createField(newData); // clone predefined
      // axios
      //   .post(`${props.predefinedEndpoint}/clone-option-reference`, {
      //     optionRefId: newData?.config?.optionReferenceId,
      //   })
      //   .then((res) => {
      //     props.addCategory(res.data.cloneOptionRef);
      //     newData.config = {
      //       ...newData.config,
      //       optionReferenceId: res.data.cloneOptionRef.id,
      //     };
      //     props.createField(newData);
      //   });
    } else {
      props.createField(newData);
    }
  };

  var showOptions = function showOptions() {
    setOptions(true);
  };

  var hideOptions = function hideOptions() {
    setOptions(false);
  };

  var renderFields = function renderFields(predefined) {
    switch (props.data.type) {
      case "text":
        return /*#__PURE__*/_react["default"].createElement(_Input["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 104,
            columnNumber: 11
          }
        });

      case "checkbox":
        return /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 108,
            columnNumber: 11
          }
        });

      case "radio":
        return /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 116,
            columnNumber: 11
          }
        });

      case "select":
        return /*#__PURE__*/_react["default"].createElement(_Select["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 124,
            columnNumber: 11
          }
        });

      case "content":
        return /*#__PURE__*/_react["default"].createElement(_Content["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 132,
            columnNumber: 11
          }
        });

      case "date":
        return /*#__PURE__*/_react["default"].createElement(_Date["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 136,
            columnNumber: 11
          }
        });

      case "file":
        return /*#__PURE__*/_react["default"].createElement(_File["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 140,
            columnNumber: 11
          }
        });

      case "image":
        return /*#__PURE__*/_react["default"].createElement(_Image["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 144,
            columnNumber: 11
          }
        });

      case "list":
        return /*#__PURE__*/_react["default"].createElement("h1", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 147,
            columnNumber: 16
          }
        }, "list");

      case "quiz":
        return /*#__PURE__*/_react["default"].createElement("h1", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 149,
            columnNumber: 16
          }
        }, "quiz");

      case "signature":
        return /*#__PURE__*/_react["default"].createElement(_Signature["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 152,
            columnNumber: 11
          }
        });

      case "survey":
        return /*#__PURE__*/_react["default"].createElement("h1", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 155,
            columnNumber: 16
          }
        }, "survey");

      case "video":
        return /*#__PURE__*/_react["default"].createElement(_Video["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 158,
            columnNumber: 11
          }
        });

      case "section":
        return /*#__PURE__*/_react["default"].createElement(_Section["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 162,
            columnNumber: 11
          }
        });

      default:
        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 165,
            columnNumber: 16
          }
        }, " Default ");
    }
  };

  var className = "wrapper ahfb-shadow-1 ahfb-bg-white ahfb-ml-3 ahfb-mr-3 ahfb-p-3 ahfb-relative";

  if (props.first) {
    className = className + " first-field";
  }

  if (props.last) {
    className = className + " last-field";
  }

  var predefined = {};
  props.predefined.map(function (item) {
    predefined[item.id] = item;
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 181,
      columnNumber: 5
    }
  }, props.data.name || props.data.type === "content" || props.data.type === "image" || props.data.type === "video" ? /*#__PURE__*/_react["default"].createElement("div", {
    className: className,
    onMouseOver: showOptions,
    onMouseLeave: hideOptions,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 186,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "innerWrapper",
    style: {
      marginTop: width < 450 ? "30px" : ""
    },
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 191,
      columnNumber: 11
    }
  }, options ? /*#__PURE__*/_react["default"].createElement(_ButtonGroup["default"], {
    className: "options-menu ahfb-absolute ahfb-" + (props.theme.direction ? props.theme.direction : "ltr") + "-1 ahfb-top-1 ahfb-float-right ahfb-zIndex",
    color: "primary",
    size: "small",
    "aria-label": "outlined primary button group",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 196,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "delete-icon",
    onClick: removeField,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 204,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react["default"].createElement(_Delete["default"], {
    fontSize: "small",
    color: "action",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 205,
      columnNumber: 19
    }
  })), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "edit-icon",
    onClick: enableEdit,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 207,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react["default"].createElement(_Edit["default"], {
    fontSize: "small",
    color: "action",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 208,
      columnNumber: 19
    }
  })), props.data.type !== "section" ? /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "clone-icon",
    onClick: cloneField,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 211,
      columnNumber: 19
    }
  }, /*#__PURE__*/_react["default"].createElement(_core.Tooltip, {
    title: "Clone field",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 212,
      columnNumber: 21
    }
  }, /*#__PURE__*/_react["default"].createElement(_FileCopy["default"], {
    fontSize: "small",
    color: "action",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 213,
      columnNumber: 23
    }
  }))) : "") : "", renderFields(predefined))) : "");
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    editId: state.toolbar.editId,
    predefined: state.form.predefined,
    predefinedEndpoint: state.form.predefinedEndpoint,
    theme: state.form.theme,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    createField: function createField(id) {
      return dispatch((0, _formActions.createField)(id));
    },
    deleteField: function deleteField(id) {
      return dispatch((0, _formActions.deleteField)(id));
    },
    enableFieldEdit: function enableFieldEdit(id) {
      return dispatch((0, _toolbarActions.enableFieldEdit)(id));
    },
    disableFieldEdit: function disableFieldEdit() {
      return dispatch((0, _toolbarActions.disableFieldEdit)());
    },
    addCategory: function addCategory(id) {
      return dispatch((0, _predefinedActions.addCategory)(id));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(FieldWrapper);

exports["default"] = _default;
module.exports = exports.default;