"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Drawer = _interopRequireDefault(require("./Drawer"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _icons = _interopRequireDefault(require("./icons"));

var _config = _interopRequireDefault(require("../../config"));

require("./styles.scss");

var _helpers = require("../../utils/helpers");

var _reactRedux = require("react-redux");

var _toolbarActions = require("../../actions/toolbarActions");

var _formActions = require("../../actions/formActions");

var _EditField = _interopRequireDefault(require("./EditField"));

var _core = require("@material-ui/core");

var _jsxFileName = "/home/mirza/code/formbuilder/src/components/toolbar/App.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var titleLabel = {
  en: 'Question Types',
  ar: 'أنواع الأسئلة'
};
var fields = [{
  label: {
    en: 'Text Field',
    ar: 'حقل نصّي'
  },
  slug: 'text',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "text",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 21,
      columnNumber: 71
    }
  })
}, {
  label: {
    en: 'Select / Dropdown',
    ar: 'حدد / منسدلة'
  },
  slug: 'select',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "select",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 22,
      columnNumber: 84
    }
  })
}, {
  label: {
    en: 'Checkbox Group',
    ar: 'مجموعة خانات الاختيار'
  },
  slug: 'checkbox',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "checkbox",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 23,
      columnNumber: 92
    }
  })
}, {
  label: {
    en: 'Radio Group',
    ar: 'مجموعة راديو'
  },
  slug: 'radio',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "checkbox",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 24,
      columnNumber: 77
    }
  })
}, {
  label: {
    en: 'Date Field',
    ar: 'حقل التاريخ'
  },
  slug: 'date',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "date",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 25,
      columnNumber: 74
    }
  })
}, {
  label: {
    en: 'Content',
    ar: 'المحتوى'
  },
  slug: 'content',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "content",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 26,
      columnNumber: 70
    }
  })
}, {
  label: {
    en: 'File Upload',
    ar: 'تحميل الملف'
  },
  slug: 'file',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "file-upload",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 27,
      columnNumber: 75
    }
  })
}, {
  label: {
    en: 'Quiz',
    ar: 'Quiz'
  },
  slug: 'quiz',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "quiz",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 28,
      columnNumber: 61
    }
  })
}, {
  label: {
    en: 'Survey',
    ar: 'Survey'
  },
  slug: 'survey',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "survey",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 29,
      columnNumber: 67
    }
  })
}, {
  label: {
    en: 'List',
    ar: 'List'
  },
  slug: 'list',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "list",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 30,
      columnNumber: 61
    }
  })
}, {
  label: {
    en: 'E-Signature',
    ar: 'التوقيع الإلكتروني'
  },
  slug: 'signature',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "signature",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 31,
      columnNumber: 87
    }
  })
}, {
  label: {
    en: 'Image',
    ar: 'صورة'
  },
  slug: 'image',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "image",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 32,
      columnNumber: 63
    }
  })
}, {
  label: {
    en: 'Video',
    ar: 'فيديو'
  },
  slug: 'video',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "video",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 33,
      columnNumber: 64
    }
  })
}, {
  label: {
    en: 'Section',
    ar: 'Section'
  },
  slug: 'section',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "section",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 34,
      columnNumber: 70
    }
  })
}];

var App = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(App, _React$Component);

  function App() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "addNewField", function (slug) {
      var data = (0, _helpers.generateSampleData)(slug, _this.props.order);

      _this.props.createField(data);
    });

    _defineProperty(_assertThisInitialized(_this), "onDragStart", function (e, slug) {
      e.dataTransfer.setData("droppedFieldSlug", slug);
    });

    _defineProperty(_assertThisInitialized(_this), "onDragEnd", function (e) {
      e.dataTransfer.setData("droppedFieldSlug", null);
    });

    _defineProperty(_assertThisInitialized(_this), "renderFieldItems", function () {
      var count = -1;
      return fields.map(function (field, index) {
        if (_config["default"].hiddenFields.indexOf(field.slug) === -1) {
          count++;
          return /*#__PURE__*/_react["default"].createElement(_core.Grid, {
            item: true,
            md: 6,
            xs: 12,
            className: count % 2 === 0 ? "ahfb-pt-3 ahfb-pr-1" : "ahfb-pt-3 ahfb-pl-1",
            key: 'field-' + field.slug,
            onDragStart: function onDragStart(e) {
              return _this.onDragStart(e, field.slug);
            },
            onDragOver: function onDragOver(e) {
              return e.preventDefault();
            },
            onDragEnd: function onDragEnd(e) {
              return _this.onDragEnd(e);
            },
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 56,
              columnNumber: 13
            }
          }, /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
            button: true,
            className: "ahfb-p-0",
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 61,
              columnNumber: 15
            }
          }, /*#__PURE__*/_react["default"].createElement("div", {
            className: "ahfb-field-type-container ahfb-pt-3 ahfb-cursor-pointer",
            onDoubleClick: function onDoubleClick(e) {
              return _this.addNewField(field.slug);
            },
            draggable: "true",
            onDragStart: function onDragStart(e) {
              return _this.onDragStart(e, field.slug);
            },
            onDragOver: function onDragOver(e) {
              return e.preventDefault();
            },
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 62,
              columnNumber: 17
            }
          }, field.icon, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
            variant: "subtitle1",
            gutterBottom: true,
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 68,
              columnNumber: 19
            }
          }, field.label[_this.props.currentLang]))));
        }

        return '';
      });
    });

    return _this;
  }

  var _proto = App.prototype;

  _proto.render = function render() {
    if (this.props.editId || this.props.newFieldData) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 84,
          columnNumber: 9
        }
      }, /*#__PURE__*/_react["default"].createElement(_Drawer["default"], {
        title: titleLabel[this.props.currentLang],
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 85,
          columnNumber: 11
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "ahfb-m-0",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 86,
          columnNumber: 13
        }
      }, /*#__PURE__*/_react["default"].createElement(_EditField["default"], {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 87,
          columnNumber: 15
        }
      }))));
    }

    return /*#__PURE__*/_react["default"].createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 94,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement(_Drawer["default"], {
      title: titleLabel[this.props.currentLang],
      type: "fields",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 95,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
      container: true,
      className: "ahfb-p-2",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 96,
        columnNumber: 11
      }
    }, this.renderFieldItems())));
  };

  return App;
}(_react["default"].Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    newFieldData: state.form.newFieldData,
    editId: state.toolbar.editId,
    data: state.form.data,
    order: state.form.order,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    enableFieldEdit: function enableFieldEdit(id, operation) {
      return dispatch((0, _toolbarActions.enableFieldEdit)(id, operation));
    },
    createField: function createField(data) {
      return dispatch((0, _formActions.createField)(data));
    },
    setOrder: function setOrder(data) {
      return dispatch((0, _formActions.setOrder)(data));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(App);

exports["default"] = _default;
module.exports = exports.default;