"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _SimpleTabs = _interopRequireDefault(require("../../../utils/Tabs/SimpleTabs"));

var _TextInput = _interopRequireDefault(require("../../../utils/inputs/TextInput"));

var _Checkbox = _interopRequireDefault(require("../../../utils/checkboxs/Checkbox"));

var _ValidateField = _interopRequireDefault(require("../../../utils/validations/ValidateField"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _toolbarActions = require("../../../actions/toolbarActions");

var _formActions = require("../../../actions/formActions");

var _reactRedux = require("react-redux");

var _dateValidation = _interopRequireDefault(require("../../../utils/date-validation"));

var _core = require("@material-ui/core");

var _richTextEditor = _interopRequireDefault(require("../../../utils/rich-text-editor"));

var _reactCustomScrollbars = require("react-custom-scrollbars");

var _SearchableSelect = _interopRequireDefault(require("../../../utils/selects/SearchableSelect"));

var _conditionalLogic = _interopRequireDefault(require("../../../utils/conditional-logic"));

var _helpers = require("../../../utils/helpers");

var _FieldRenderer = _interopRequireDefault(require("./utils/FieldRenderer"));

var _radioFieldConfigs = require("./utils/radioFieldConfigs");

var _dateFieldConfigs = require("./utils/dateFieldConfigs");

var _helpers2 = require("./utils/helpers");

var _jsxFileName = "/home/mirza/code/formbuilder/src/components/toolbar/field-forms/Date.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var basicTabTitle = {
  en: 'Basic Settings',
  ar: 'الإعدادات الأساسية'
};
var advanceTabTitle = {
  en: 'Advance Settings',
  ar: 'إعدادات متقدمة'
};
var machineNameLabel = {
  en: 'Machine Name/Field ID',
  ar: 'إسم الألة'
};
var visibilityLabel = {
  en: 'Visibility to Employee',
  ar: 'الرؤية للموظف'
};
var cancelLabel = {
  en: 'Cancel',
  ar: 'إلغاء'
};
var saveLabel = {
  en: 'Save',
  ar: 'حفظ'
};
var visibleLabel = {
  en: 'Visible',
  ar: 'مرئي'
};
var hiddenLabel = {
  en: 'Hidden',
  ar: 'مختفي'
};

var Select = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Select, _React$Component);

  function Select(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleTabChange", function (e, newValue) {
      _this.setState({
        activeTab: newValue
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleDataChange", function (val, name) {
      var _this$setState;

      _this.setState((_this$setState = {}, _this$setState[name] = val, _this$setState.errors = {}, _this$setState));
    });

    _defineProperty(_assertThisInitialized(_this), "saveField", function () {
      var _this$state = _this.state,
          name = _this$state.name,
          machineName = _this$state.machineName,
          order = _this$state.order,
          conditionalLogic = _this$state.conditionalLogic,
          isRequired = _this$state.isRequired,
          placeholder = _this$state.placeholder,
          helpText = _this$state.helpText,
          subType = _this$state.subType,
          visibility = _this$state.visibility,
          uuid = _this$state.uuid,
          type = _this$state.type,
          isMultiple = _this$state.isMultiple,
          shouldDateValidate = _this$state.shouldDateValidate,
          isReminder = _this$state.isReminder,
          reminderLogic = _this$state.reminderLogic,
          quantity = _this$state.quantity,
          reminderType = _this$state.reminderType,
          conditions = _this$state.conditions,
          template_html = _this$state.template_html,
          dateValidations = _this$state.dateValidations,
          parentId = _this$state.parentId;
      var newField = {
        name: name,
        machineName: machineName,
        order: order,
        uuid: uuid,
        type: type,
        parentId: parentId,
        isReminder: isReminder,
        config: {
          reminderLogic: reminderLogic,
          isReminder: isReminder,
          conditionalLogic: conditionalLogic,
          isConditionalEnabled: !!conditionalLogic.conditions.length,
          isRequired: isRequired,
          placeholder: placeholder,
          helpText: helpText,
          subType: subType,
          visibility: visibility,
          isMultiple: isMultiple,
          shouldDateValidate: shouldDateValidate,
          dateValidations: dateValidations
        }
      };
      newField.locals = (0, _helpers2.processLocalFields)(_this.props.locals, _this.state);
      (0, _ValidateField["default"])(newField, null, _this.props.currentLang).then(function () {
        _this.props.updateField(newField);

        _this.props.disableFieldEdit();
      })["catch"](function (errors) {
        var keys = Object.keys(errors);

        if (keys[0] === 'machineName' || keys[0] === 'conditionalLogic') {
          _this.handleTabChange({}, 'advance');
        } else {
          _this.handleTabChange({}, 'basic');
        }

        _this.setState({
          errors: errors
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "cancelEdit", function () {
      _this.props.deleteNewField();

      _this.props.disableFieldEdit();
    });

    _defineProperty(_assertThisInitialized(_this), "handleDateValidationChange", function (value, name) {
      if (name === 'shouldDateValidate') {
        if (!value) {
          var _this$setState2;

          _this.setState((_this$setState2 = {}, _this$setState2[name] = value, _this$setState2.dateValidations = {
            pastUnit: 'days',
            pastMax: 0,
            pastMin: 0,
            futureUnit: 'days',
            futureMax: 0,
            futureMin: 0
          }, _this$setState2));
        } else {
          var _this$setState3;

          _this.setState((_this$setState3 = {}, _this$setState3[name] = value, _this$setState3));
        }
      } else {
        if (name === 'shouldPastDateValidate') {
          var _extends2;

          _this.setState({
            dateValidations: _extends({}, _this.state.dateValidations, (_extends2 = {}, _extends2[name] = value, _extends2.pastUnit = 'days', _extends2.pastMax = 0, _extends2.pastMin = 0, _extends2))
          });
        } else if (name === 'shouldFutureDateValidate') {
          var _extends3;

          _this.setState({
            dateValidations: _extends({}, _this.state.dateValidations, (_extends3 = {}, _extends3[name] = value, _extends3.futureUnit = 'days', _extends3.futureMax = 0, _extends3.futureMin = 0, _extends3))
          });
        } else {
          var _extends4;

          _this.setState({
            dateValidations: _extends({}, _this.state.dateValidations, (_extends4 = {}, _extends4[name] = value, _extends4))
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleReminderChange", function (value, name) {
      if (name === 'isReminder') {
        var _extends5;

        _this.setState(_extends({}, _this.state, (_extends5 = {}, _extends5[name] = value, _extends5)));
      } else {
        var _extends6;

        _this.setState(_extends({}, _this.state, {
          reminderLogic: _extends({}, _this.state.reminderLogic, (_extends6 = {}, _extends6[name] = value, _extends6))
        }));
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderTabFields", function () {
      if (_this.state.activeTab === 'basic') {
        var _this$state$errors;

        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 217,
            columnNumber: 9
          }
        }, /*#__PURE__*/_react["default"].createElement(_FieldRenderer["default"], _extends({}, _this.state, {
          locals: _this.props.locals,
          fieldConfigs: _dateFieldConfigs.dateFieldsConfigs,
          handleDataChange: _this.handleDataChange,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 218,
            columnNumber: 11
          }
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 232,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_dateValidation["default"], _extends({
          currentLang: _this.props.currentLang,
          errors: (_this$state$errors = _this.state.errors) == null ? void 0 : _this$state$errors.dateErrors,
          shouldDateValidate: _this.state.shouldDateValidate,
          handleChange: _this.handleDateValidationChange,
          handleReminderChange: _this.handleReminderChange
        }, _this.state.dateValidations, _this.state, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 233,
            columnNumber: 13
          }
        }))));
      } else {
        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 239,
            columnNumber: 9
          }
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 240,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
          value: _this.state.machineName,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'machineName');
          },
          label: machineNameLabel[_this.props.currentLang],
          required: true,
          autoFocus: true,
          error: _this.state.errors.machineName,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 241,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 243,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
          options: [{
            label: visibleLabel[_this.props.currentLang],
            value: 'visible'
          }, {
            label: hiddenLabel[_this.props.currentLang],
            value: 'hidden'
          }],
          label: visibilityLabel[_this.props.currentLang],
          value: _this.state.visibility ? 'visible' : 'hidden',
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value === 'visible', 'visibility');
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 244,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement(_conditionalLogic["default"], {
          predefined: _this.props.predefined,
          conditionalLogic: _this.state.conditionalLogic,
          isConditionalEnabled: _this.state.isConditionalEnabled,
          handleChange: _this.handleDataChange,
          errors: _this.state.errors.conditionalLogic ? _this.state.errors.conditionalLogic : [],
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 246,
            columnNumber: 11
          }
        }));
      }
    });

    _this.state = _extends({
      activeTab: 'basic',
      errors: {},
      uuid: props.data.uuid,
      name: props.data.name,
      type: props.data.type,
      order: props.data.order,
      parentId: props.data.parentId,
      machineName: props.data.machineName,
      reminderLogic: props.data.reminderLogic ? props.data.reminderLogic : {
        quantity: 1,
        type: 'days',
        conditions: 'after',
        template_html: '<p>Hi <strong>%user_name%</strong>, This is a quick reminder to update you that the <strong>%field_title%</strong> it&#39;s going to expire on <strong>%date_time%</strong> But it&rsquo;s still not too late! In order to continue taking advantage of that, we will suggest you kindly update it.</p><p><br />Thank you.</p>'
      }
    }, props.data.config);
    return _this;
  }

  var _proto = Select.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.data.uuid !== this.state.uuid) {
      this.setState(_extends({
        activeTab: 'basic',
        errors: {},
        uuid: nextProps.data.uuid,
        name: nextProps.data.name,
        type: nextProps.data.type,
        order: nextProps.data.order,
        parentId: nextProps.data.parentId,
        machineName: nextProps.data.machineName,
        reminderLogic: props.data.reminderLogic ? props.data.reminderLogic : {
          quantity: 1,
          type: 'days',
          conditions: 'after',
          template_html: '<p>Hi <strong>%user_name%</strong>, This is a quick reminder to update you that the <strong>%field_title%</strong> it&#39;s going to expire on <strong>%date_time%</strong> But it&rsquo;s still not too late! In order to continue taking advantage of that, we will suggest you kindly update it.</p><p><br />Thank you.</p>'
        }
      }, nextProps.data.config));
    }
  };

  _proto.render = function render() {
    var _this2 = this;

    return /*#__PURE__*/_react["default"].createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 254,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement(_SimpleTabs["default"], {
      value: this.state.activeTab,
      handleChange: this.handleTabChange,
      options: [{
        label: basicTabTitle[this.props.currentLang],
        value: 'basic'
      }, {
        label: advanceTabTitle[this.props.currentLang],
        value: 'advance'
      }],
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 255,
        columnNumber: 9
      }
    }), /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars.Scrollbars, {
      style: {
        height: (0, _helpers.getHeight)(true, true)
      },
      autoHide: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 256,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-p-3 ahfb-my-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 257,
        columnNumber: 11
      }
    }, this.renderTabFields(), /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-width-full ahfb-text-right",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 259,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "outlined",
      color: "primary",
      className: "ahfb-mr-2",
      onClick: this.cancelEdit,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 260,
        columnNumber: 15
      }
    }, cancelLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "contained",
      color: "primary",
      disableElevation: true,
      onClick: function onClick() {
        _this2.handleReminderChange(_this2.template_html, 'template_html');

        _this2.saveField();
      },
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 263,
        columnNumber: 15
      }
    }, saveLabel[this.props.currentLang])))));
  };

  return Select;
}(_react["default"].Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    operation: state.toolbar.operation,
    predefined: state.form.predefined,
    locals: state.form.locals,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    disableFieldEdit: function disableFieldEdit() {
      return dispatch((0, _toolbarActions.disableFieldEdit)());
    },
    deleteNewField: function deleteNewField() {
      return dispatch((0, _formActions.deleteNewField)());
    },
    createField: function createField(data) {
      return dispatch((0, _formActions.createField)(data));
    },
    updateField: function updateField(data) {
      return dispatch((0, _formActions.updateField)(data));
    },
    deleteField: function deleteField(id) {
      return dispatch((0, _formActions.deleteField)(id));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Select);

exports["default"] = _default;
module.exports = exports.default;