"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireDefault(require("react"));

var _SimpleTabs = _interopRequireDefault(require("../../../utils/Tabs/SimpleTabs"));

var _TextInput = _interopRequireDefault(require("../../../utils/inputs/TextInput"));

var _Checkbox = _interopRequireDefault(require("../../../utils/checkboxs/Checkbox"));

var _ValidateField = _interopRequireDefault(require("../../../utils/validations/ValidateField"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _toolbarActions = require("../../../actions/toolbarActions");

var _formActions = require("../../../actions/formActions");

var _reactRedux = require("react-redux");

var _predefinedValues = _interopRequireDefault(require("../../../utils/predefined-values"));

var _choices = _interopRequireDefault(require("../../../utils/choices"));

var _core = require("@material-ui/core");

var _reactCustomScrollbars = require("react-custom-scrollbars");

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _conditionalLogic = _interopRequireDefault(require("../../../utils/conditional-logic"));

var _axios = _interopRequireDefault(require("axios"));

var _predefinedActions = require("../../../actions/predefinedActions");

var _SearchableSelect = _interopRequireDefault(require("../../../utils/selects/SearchableSelect"));

var _helpers = require("../../../utils/helpers");

var _FieldRenderer = _interopRequireDefault(require("./utils/FieldRenderer"));

var _textFieldConfigs = require("./utils/textFieldConfigs");

var _selectFieldConfigs = require("./utils/selectFieldConfigs");

var _helpers2 = require("./utils/helpers");

var _icons = require("@material-ui/icons");

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _jsxFileName = "/home/mirza/code/formbuilder/src/components/toolbar/field-forms/Select.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var basicTabTitle = {
  en: "Basic Settings",
  ar: "الإعدادات الأساسية"
};
var advanceTabTitle = {
  en: "Advance Settings",
  ar: "إعدادات متقدمة"
};
var machineNameLabel = {
  en: "Machine Name/Field ID",
  ar: "إسم الألة"
};
var visibilityLabel = {
  en: "Visibility to Employee",
  ar: "الرؤية للموظف"
};
var cancelLabel = {
  en: "Cancel",
  ar: "إلغاء"
};
var saveLabel = {
  en: "Save",
  ar: "حفظ"
};
var choiceLabel = {
  en: "Choices",
  ar: "خيارات"
};
var multiSelectLabel = {
  en: "Allow multiselect",
  ar: "السماح بالاختيار المتعدد"
};
var enableOtherChoiceLabel = {
  en: 'Enable "Other" Choice',
  ar: "تمكين خيار آخر"
};
var visibleLabel = {
  en: "Visible",
  ar: "مرئي"
};
var hiddenLabel = {
  en: "Hidden",
  ar: "مختفي"
};

var Select = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Select, _React$Component);

  function Select(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleTabChange", function (e, newValue) {
      _this.setState({
        activeTab: newValue
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleDataChange", function (val, name) {
      var _this$setState;

      if (name === "machineName") {
        _this.setState(_extends({}, _this.state, {
          updatedMachineName: val
        }));

        return;
      }

      _this.setState((_this$setState = {}, _this$setState[name] = val, _this$setState));
    });

    _defineProperty(_assertThisInitialized(_this), "handleSaveField", function () {
      //check if machine name already exist
      var machineName = _this.state.machineName;

      if (machineName && _this.props.isOptionUpdated) {
        _axios["default"].get(_this.props.predefinedEndpoint + "/checkMachineNameExist/" + machineName + "/" + _this.state.uuid).then(function (response) {
          var _response$data;

          if (response == null ? void 0 : (_response$data = response.data) == null ? void 0 : _response$data.isExist) {
            _this.setState(_extends({}, _this.state, {
              isSameMachineName: response.data.field
            }));
          } else {
            _this.saveField();
          }
        });
      } else {
        _this.saveField();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "saveField", /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _this$state, name, machineName, order, conditionalLogic, isRequired, placeholder, helpText, subType, visibility, uuid, type, isMultiple, optionReferenceId, enableOther, parentId, optionRef, res, _res$data, newField;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this$state = _this.state, name = _this$state.name, machineName = _this$state.machineName, order = _this$state.order, conditionalLogic = _this$state.conditionalLogic, isRequired = _this$state.isRequired, placeholder = _this$state.placeholder, helpText = _this$state.helpText, subType = _this$state.subType, visibility = _this$state.visibility, uuid = _this$state.uuid, type = _this$state.type, isMultiple = _this$state.isMultiple, optionReferenceId = _this$state.optionReferenceId, enableOther = _this$state.enableOther, parentId = _this$state.parentId;
              optionRef = _this.props.predefined.find(function (item) {
                return item.id === optionReferenceId;
              });

              if (!optionReferenceId) {
                _context.next = 14;
                break;
              }

              _context.prev = 3;

              if (!optionRef) {
                _context.next = 9;
                break;
              }

              _context.next = 7;
              return _axios["default"].post(_this.props.predefinedEndpoint + "/updateOptionRef", {
                data: optionRef
              });

            case 7:
              res = _context.sent;

              if (res == null ? void 0 : res.data) {
                _this.props.addCategory(res.data);

                _this.setState(_extends({}, _this.state, {
                  optionReferenceId: res.data.id
                }));

                optionReferenceId = res == null ? void 0 : (_res$data = res.data) == null ? void 0 : _res$data.id;
              }

            case 9:
              _context.next = 14;
              break;

            case 11:
              _context.prev = 11;
              _context.t0 = _context["catch"](3);
              console.log(_context.t0);

            case 14:
              newField = {
                name: name,
                machineName: machineName,
                uuid: uuid,
                type: type,
                order: order,
                parentId: parentId,
                config: {
                  conditionalLogic: conditionalLogic,
                  isConditionalEnabled: !!conditionalLogic.conditions.length,
                  isRequired: isRequired,
                  placeholder: placeholder,
                  helpText: helpText,
                  subType: subType,
                  visibility: visibility,
                  isMultiple: isMultiple,
                  optionReferenceId: optionReferenceId,
                  optionRef: optionRef,
                  enableOther: enableOther
                }
              };
              newField.locals = (0, _helpers2.processLocalFields)(_this.props.locals, _this.state);
              (0, _ValidateField["default"])(newField, null, _this.props.currentLang).then(function () {
                _this.props.updateField(newField);

                _this.props.disableFieldEdit();

                _this.props.setIsOptionUpdated(false);
              })["catch"](function (errors) {
                var keys = Object.keys(errors);

                if (keys[0] === "machineName" || keys[0] === "conditionalLogic") {
                  _this.handleTabChange({}, "advance");
                } else {
                  _this.handleTabChange({}, "basic");
                }

                _this.setState({
                  errors: errors
                });
              });

            case 17:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[3, 11]]);
    })));

    _defineProperty(_assertThisInitialized(_this), "cancelEdit", function () {
      _this.props.disableFieldEdit();

      _this.props.deleteNewField();
    });

    _defineProperty(_assertThisInitialized(_this), "updateChoices", function (options) {
      _this.setState({
        options: options
      });
    });

    _defineProperty(_assertThisInitialized(_this), "insertChoices", function (cat) {
      //if it is system predefined options we can replace the reference
      if (cat.is_secure) {
        _this.setState(_extends({}, _this.state, {
          optionReferenceId: cat.id
        }));

        return;
      }

      var preDef = _this.props.predefined.find(function (item) {
        return item.id === _this.state.optionReferenceId;
      }); // clone predefined


      if (!_this.state.optionReferenceId || preDef.is_secure) {
        var clonePredef = {
          id: (0, _helpers.getUniqueNumber)(),
          name: cat.name + '_clone_' + (0, _helpers.getUniqueNumber)(),
          slug: cat.slug + '_clone_' + (0, _helpers.getUniqueNumber)(),
          is_public: false,
          is_secure: false,
          isNew: true,
          options: cat.options.map(function (item) {
            return _extends({}, item, {
              id: (0, _helpers.getUniqueNumber)()
            });
          })
        };

        _this.props.addCategory(clonePredef);

        _this.setState(_extends({}, _this.state, {
          optionReferenceId: clonePredef.id
        }));
      } else {
        var updatedOptions = [].concat(preDef.options, cat.options.map(function (item) {
          return _extends({}, item, {
            id: (0, _helpers.getUniqueNumber)(),
            saveType: 'new'
          });
        }));

        _this.props.updateCategoryOptions(updatedOptions, preDef.slug);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "disablePredefined", function () {
      return new Promise(function (resolve, reject) {
        var options = [];

        for (var i = 0; i < _this.props.predefined.length; i++) {
          if (_this.props.predefined[i].id === _this.state.optionReferenceId) {
            _this.props.predefined[i].options.map(function (option) {
              options.push({
                name: option.name,
                value: option.value
              });
            });

            break;
          }
        }

        var newOptRef = {
          id: (0, _helpers.getUniqueNumber)(),
          isNew: true,
          name: _this.state.machineName,
          slug: _this.state.machineName,
          isPublic: false,
          options: options
        };

        _this.props.addCategory(newOptRef);

        _this.setState({
          optionReferenceId: newOptRef.id
        }, function () {
          resolve(newOptRef);
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "hanldeUpdateMachineName", function () {
      var updatedMachineName = _this.state.updatedMachineName;

      if (updatedMachineName) {
        var _Object$values;

        var haveMachineName = (_Object$values = Object.values(_this.props.fields)) == null ? void 0 : _Object$values.filter(function (item) {
          return item.machineName === updatedMachineName;
        });

        if (haveMachineName.length) {
          _this.setState(_extends({}, _this.state, {
            errors: _extends({}, _this.errors, {
              machineName: 'Machine name already exist in this form!'
            })
          }));
        } else {
          _axios["default"].get(_this.props.predefinedEndpoint + "/checkMachineNameExist/" + updatedMachineName + "/" + _this.state.uuid).then(function (response) {
            var _response$data2;

            if (response == null ? void 0 : (_response$data2 = response.data) == null ? void 0 : _response$data2.isExist) {
              _this.setState(_extends({}, _this.state, {
                sameMachineNameField: response.data.field,
                errors: _extends({}, _this.errors, {
                  machineName: null
                })
              }));
            } else {
              _this.setState(_extends({}, _this.state, {
                machineName: updatedMachineName,
                errors: _extends({}, _this.errors, {
                  machineName: null
                })
              }));
            }
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderTabFields", function () {
      if (_this.state.activeTab === "basic") {
        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 369,
            columnNumber: 9
          }
        }, /*#__PURE__*/_react["default"].createElement(_FieldRenderer["default"], _extends({}, _this.state, {
          locals: _this.props.locals,
          fieldConfigs: _selectFieldConfigs.selectFieldsConfigs,
          handleDataChange: _this.handleDataChange,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 370,
            columnNumber: 11
          }
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 390,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_choices["default"], {
          disablePredefined: _this.disablePredefined,
          predefined: _this.props.predefined,
          optionReferenceId: _this.state.optionReferenceId,
          required: true,
          label: choiceLabel[_this.props.currentLang],
          updateChoices: _this.updateChoices,
          choices: _this.state.options,
          error: _this.state.errors.options,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 391,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement(_predefinedValues["default"], {
          insertChoices: _this.insertChoices,
          selected: _this.state.optionReferenceId,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 402,
            columnNumber: 11
          }
        }), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-0",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 406,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          checked: _this.state.isMultiple,
          handleChange: function handleChange(val) {
            return _this.handleDataChange(val, "isMultiple");
          },
          label: multiSelectLabel[_this.props.currentLang],
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 407,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 413,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          checked: _this.state.enableOther,
          handleChange: function handleChange(val) {
            return _this.handleDataChange(val, "enableOther");
          },
          label: enableOtherChoiceLabel[_this.props.currentLang],
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 414,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement(_core.Dialog, {
          open: !!_this.state.isSameMachineName,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 420,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_core.DialogTitle, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 421,
            columnNumber: 13
          }
        }, "Same Machine Name Alert"), /*#__PURE__*/_react["default"].createElement(_core.DialogContent, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 422,
            columnNumber: 13
          }
        }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 423,
            columnNumber: 15
          }
        }, " Field(s) with this ", /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
          display: "inline",
          color: "secondary",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 423,
            columnNumber: 47
          }
        }, " ", _this.state.updatedMachineName, " "), " machine name already exist. if you proceed choices will reflect to other fields of same machine name ")), /*#__PURE__*/_react["default"].createElement(_core.DialogActions, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 426,
            columnNumber: 13
          }
        }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
          variant: "outlined",
          color: "primary",
          className: "ahfb-mr-2",
          onClick: function onClick() {
            return _this.setState(_extends({}, _this.state, {
              isSameMachineName: null
            }));
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 428,
            columnNumber: 15
          }
        }, "close"), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
          variant: "contained",
          color: "primary",
          disableElevation: true,
          onClick: _this.saveField,
          autoFocus: true,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 441,
            columnNumber: 15
          }
        }, "Proceed"))));
      } else {
        var _this$state2, _this$state2$sameMach;

        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 456,
            columnNumber: 9
          }
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 457,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
          value: _this.state.updatedMachineName || _this.state.updatedMachineName === "" ? _this.state.updatedMachineName : _this.state.machineName,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, "machineName");
          },
          label: machineNameLabel[_this.props.currentLang],
          required: true,
          autoFocus: true,
          error: _this.state.errors.machineName,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 458,
            columnNumber: 13
          }
        }), _this.state.updatedMachineName && _this.state.updatedMachineName !== _this.state.machineName && /*#__PURE__*/_react["default"].createElement("div", {
          style: {
            display: "flex",
            justifyContent: "end"
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 475,
            columnNumber: 17
          }
        }, /*#__PURE__*/_react["default"].createElement(_core.IconButton, {
          size: "small",
          onClick: function onClick() {
            return _this.setState(_extends({}, _this.state, {
              updatedMachineName: null,
              errors: _extends({}, _this.errors, {
                machineName: null
              })
            }));
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 476,
            columnNumber: 19
          }
        }, /*#__PURE__*/_react["default"].createElement(_icons.Close, {
          fontSize: "small",
          color: "secondary",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 489,
            columnNumber: 21
          }
        })), /*#__PURE__*/_react["default"].createElement(_core.IconButton, {
          size: "small",
          onClick: _this.hanldeUpdateMachineName,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 491,
            columnNumber: 19
          }
        }, /*#__PURE__*/_react["default"].createElement(_icons.Check, {
          fontSize: "small",
          color: "primary",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 495,
            columnNumber: 21
          }
        })))), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 500,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
          options: [{
            label: visibleLabel[_this.props.currentLang],
            value: "visible"
          }, {
            label: hiddenLabel[_this.props.currentLang],
            value: "hidden"
          }],
          label: visibilityLabel[_this.props.currentLang],
          value: _this.state.visibility ? "visible" : "hidden",
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value === "visible", "visibility");
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 501,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement(_conditionalLogic["default"], {
          conditionalLogic: _this.state.conditionalLogic,
          isConditionalEnabled: _this.state.isConditionalEnabled,
          handleChange: _this.handleDataChange,
          errors: _this.state.errors.conditionalLogic ? _this.state.errors.conditionalLogic : [],
          predefined: _this.props.predefined,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 519,
            columnNumber: 11
          }
        }), /*#__PURE__*/_react["default"].createElement(_core.Dialog, {
          open: !!_this.state.sameMachineNameField,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 531,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_core.DialogTitle, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 532,
            columnNumber: 13
          }
        }, " Same Machine Name Alert!"), /*#__PURE__*/_react["default"].createElement(_core.DialogContent, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 533,
            columnNumber: 13
          }
        }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 534,
            columnNumber: 15
          }
        }, "Field(s) with this ", /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
          display: "inline",
          color: "secondary",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 535,
            columnNumber: 36
          }
        }, " ", (_this$state2 = _this.state) == null ? void 0 : (_this$state2$sameMach = _this$state2.sameMachineNameField) == null ? void 0 : _this$state2$sameMach.machine_name, " "), " machine name already exist. if you proceed the choices will be replaced with existing one!")), /*#__PURE__*/_react["default"].createElement(_core.DialogActions, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 539,
            columnNumber: 13
          }
        }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
          variant: "outlined",
          color: "primary",
          className: "ahfb-mr-2",
          onClick: function onClick() {
            return _this.setState(_extends({}, _this.state, {
              sameMachineNameField: null
            }));
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 540,
            columnNumber: 15
          }
        }, "close"), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
          variant: "contained",
          color: "primary",
          disableElevation: true,
          onClick: function onClick() {
            return _this.setState(_extends({}, _this.state, {
              machineName: _this.state.updatedMachineName,
              optionReferenceId: _this.state.sameMachineNameField.options_reference_id,
              sameMachineNameField: null
            }));
          },
          autoFocus: true,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 553,
            columnNumber: 15
          }
        }, "Procced"))));
      }
    });

    _this.state = _extends({
      activeTab: "basic",
      errors: {},
      uuid: props.data.uuid,
      name: props.data.name,
      type: props.data.type,
      order: props.data.order,
      parentId: props.data.parentId,
      machineName: props.data.machineName
    }, props.data.config);
    return _this;
  }

  var _proto = Select.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.data.uuid !== this.state.uuid) {
      this.setState(_extends({
        activeTab: "basic",
        errors: {},
        uuid: nextProps.data.uuid,
        name: nextProps.data.name,
        type: nextProps.data.type,
        order: nextProps.data.order,
        parentId: nextProps.data.parentId,
        machineName: nextProps.data.machineName
      }, nextProps.data.config));
    }
  };

  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 580,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement(_SimpleTabs["default"], {
      value: this.state.activeTab,
      handleChange: this.handleTabChange,
      options: [{
        label: basicTabTitle[this.props.currentLang],
        value: "basic"
      }, {
        label: advanceTabTitle[this.props.currentLang],
        value: "advance"
      }],
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 581,
        columnNumber: 9
      }
    }), /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars.Scrollbars, {
      style: {
        height: (0, _helpers.getHeight)(true, true)
      },
      autoHide: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 592,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-p-3 ahfb-my-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 593,
        columnNumber: 11
      }
    }, this.renderTabFields(), /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-width-full ahfb-text-right",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 595,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "outlined",
      color: "primary",
      className: "ahfb-mr-2",
      onClick: this.cancelEdit,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 596,
        columnNumber: 15
      }
    }, cancelLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "contained",
      color: "primary",
      disableElevation: true,
      onClick: this.handleSaveField,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 604,
        columnNumber: 15
      }
    }, saveLabel[this.props.currentLang])))));
  };

  return Select;
}(_react["default"].Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    operation: state.toolbar.operation,
    predefined: state.form.predefined,
    predefinedEndpoint: state.form.predefinedEndpoint,
    locals: state.form.locals,
    currentLang: state.form.currentLang,
    isOptionUpdated: state.form.isOptionUpdated,
    fields: state.form.data
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    disableFieldEdit: function disableFieldEdit() {
      return dispatch((0, _toolbarActions.disableFieldEdit)());
    },
    deleteNewField: function deleteNewField() {
      return dispatch((0, _formActions.deleteNewField)());
    },
    createField: function createField(data) {
      return dispatch((0, _formActions.createField)(data));
    },
    updateField: function updateField(data) {
      return dispatch((0, _formActions.updateField)(data));
    },
    deleteField: function deleteField(id) {
      return dispatch((0, _formActions.deleteField)(id));
    },
    addCategory: function addCategory(id) {
      return dispatch((0, _predefinedActions.addCategory)(id));
    },
    updateCategoryOptions: function updateCategoryOptions(data, slug) {
      return dispatch((0, _predefinedActions.updateCategoryOptions)(data, slug));
    },
    setIsOptionUpdated: function setIsOptionUpdated(value) {
      return dispatch((0, _predefinedActions.setIsOptionUpdated)(value));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Select);

exports["default"] = _default;
module.exports = exports.default;