"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("@material-ui/core/styles");

var _Tabs = _interopRequireDefault(require("@material-ui/core/Tabs"));

var _Tab = _interopRequireDefault(require("@material-ui/core/Tab"));

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _InputLabel = _interopRequireDefault(require("@material-ui/core/InputLabel"));

var _Select = _interopRequireDefault(require("@material-ui/core/Select"));

var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _reactRedux = require("react-redux");

var _formActions = require("../../actions/formActions");

var _jsxFileName = "/home/mirza/code/formbuilder/src/utils/Tabs/SimpleTabs.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var addLangLabel = {
  en: 'Add Langauge',
  ar: 'إضافة لغة'
};
var selectLangLabel = {
  en: 'Select Language',
  ar: 'اختار اللغة'
};

var useStyles = function useStyles(theme) {
  return {
    root: {
      flexGrow: 1,
      backgroundColor: theme.palette.background.paper
    }
  };
};

var SimpleTabs = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(SimpleTabs, _React$Component);

  function SimpleTabs() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = SimpleTabs.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.props.setAddLanguageSelect({
      target: {
        value: ''
      }
    });
  };

  _proto.render = function render() {
    var _this = this;

    var _this$props = this.props,
        value = _this$props.value,
        handleChange = _this$props.handleChange,
        options = _this$props.options,
        classes = _this$props.classes,
        locals = _this$props.locals,
        addLanguageSelect = _this$props.addLanguageSelect;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: classes.root,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 40,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement(_Paper["default"], {
      square: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 41,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement(_Tabs["default"], {
      variant: "fullWidth",
      value: value,
      indicatorColor: "primary",
      textColor: "primary",
      onChange: handleChange,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 42,
        columnNumber: 11
      }
    }, options.map(function (option) {
      return /*#__PURE__*/_react["default"].createElement(_Tab["default"], {
        key: "tab-" + option.value,
        value: option.value,
        label: option.label,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 50,
          columnNumber: 15
        }
      });
    }))), locals && locals.length !== 0 && /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-width-ful ahfb-px-3 ahfb-mt-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 57,
        columnNumber: 11
      }
    }, /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
      container: true,
      spacing: 3,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 58,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
      item: true,
      xs: 12,
      md: 3,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 59,
        columnNumber: 15
      }
    }, /*#__PURE__*/_react["default"].createElement("label", {
      className: "ahfb-mt-3 ahfb-align-center",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 60,
        columnNumber: 17
      }
    }, addLangLabel[this.props.currentLang])), /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
      item: true,
      xs: 12,
      md: 9,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 62,
        columnNumber: 15
      }
    }, /*#__PURE__*/_react["default"].createElement(_FormControl["default"], {
      className: "ahfb-width-ful ahfb-d-flex",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 63,
        columnNumber: 17
      }
    }, /*#__PURE__*/_react["default"].createElement(_InputLabel["default"], {
      id: "demo-simple-select-label",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 64,
        columnNumber: 19
      }
    }, selectLangLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_Select["default"], {
      labelId: "demo-simple-select-label",
      id: "demo-simple-select",
      value: addLanguageSelect,
      onClick: this.props.setAddLanguageSelect,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 65,
        columnNumber: 19
      }
    }, locals.map(function (locale) {
      return /*#__PURE__*/_react["default"].createElement(_MenuItem["default"], {
        key: locale.key,
        value: locale.key,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 72,
          columnNumber: 23
        }
      }, locale.name);
    })))))));
  };

  return SimpleTabs;
}(_react["default"].Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    locals: state.form.locals,
    addLanguageSelect: state.form.addLanguageSelect,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setAddLanguageSelect: function setAddLanguageSelect(e) {
      return dispatch((0, _formActions.setAddLanguageSelect)(e.target.value));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)((0, _styles.withStyles)(useStyles)(SimpleTabs));

exports["default"] = _default;
module.exports = exports.default;