"use strict";

exports.__esModule = true;
exports["default"] = NewCategory;

var _react = _interopRequireDefault(require("react"));

var _TextInput = _interopRequireDefault(require("../inputs/TextInput"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Done = _interopRequireDefault(require("@material-ui/icons/Done"));

var _Close = _interopRequireDefault(require("@material-ui/icons/Close"));

var _jsxFileName = "/home/mirza/code/formbuilder/src/utils/predefined-values/NewCategory.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var sameNameError = {
  en: 'Category with same name already exists.',
  ar: 'الفئة التي تحمل نفس الاسم موجودة بالفعل.'
};
var nameRequiredError = {
  en: 'Category name is required.',
  ar: 'مطلوب اسم الفئة'
};
var placeholderLabel = {
  en: 'Category Name',
  ar: 'اسم التصنيف'
};

function NewCategory(props) {
  var _React$useState = _react["default"].useState(''),
      value = _React$useState[0],
      setValue = _React$useState[1];

  var _React$useState2 = _react["default"].useState(''),
      error = _React$useState2[0],
      setError = _React$useState2[1];

  var handleChange = function handleChange(e) {
    setError('');
    setValue(e.target.value);
  };

  var saveNewCategory = function saveNewCategory() {
    if (props.names.includes(value.toLocaleLowerCase())) {
      setError(sameNameError[props.currentLang]);
    } else if (!value.length) {
      setError(nameRequiredError[props.currentLang]);
    } else {
      props.saveNewCategory(value);
    }
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "ahfb-pl-3",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 40,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    placeholder: placeholderLabel[props.currentLang],
    value: value,
    handleChange: handleChange,
    autoFocus: true,
    error: error,
    endAdornment: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 48,
        columnNumber: 11
      }
    }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      size: "small",
      onClick: saveNewCategory,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 49,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react["default"].createElement(_Done["default"], {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 49,
        columnNumber: 64
      }
    })), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      size: "small",
      onClick: props.handleAddCategoryClose,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 50,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react["default"].createElement(_Close["default"], {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 50,
        columnNumber: 77
      }
    }))),
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 41,
      columnNumber: 7
    }
  }));
}

module.exports = exports.default;