"use strict";

exports.__esModule = true;
exports["default"] = SearchableSelect;

var _react = _interopRequireDefault(require("react"));

var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));

var _Autocomplete = _interopRequireDefault(require("@material-ui/lab/Autocomplete"));

var _FormLabel = _interopRequireDefault(require("@material-ui/core/FormLabel"));

var _styles = require("@material-ui/core/styles");

var _jsxFileName = "/home/mirza/code/formbuilder/src/utils/selects/SearchableSelect.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    labelRoot: {
      transform: 'none'
    }
  };
});

function SearchableSelect(props) {
  var _this = this;

  var classes = useStyles();
  var options = props.options,
      value = props.value,
      handleChange = props.handleChange,
      label = props.label,
      error = props.error,
      required = props.required,
      placeholder = props.placeholder,
      helperText = props.helperText,
      disabled = props.disabled,
      disableClearable = props.disableClearable;
  var labelProp = props.labelProp ? props.labelProp : 'label';
  var valueProp = props.valueProp ? props.valueProp : 'value';
  var formattedValue = null;

  for (var i = 0; i < options.length; i++) {
    if (options[i][valueProp] === value) {
      formattedValue = options[i];
    }
  }

  return /*#__PURE__*/_react["default"].createElement(_Autocomplete["default"], {
    disablePortal: true,
    value: formattedValue,
    options: options,
    disabled: disabled,
    getOptionLabel: function getOptionLabel(option) {
      return option[labelProp];
    },
    onChange: function onChange(e, value) {
      handleChange({
        target: {
          value: value[valueProp]
        }
      });
    },
    disableClearable: disableClearable,
    renderInput: function renderInput(params) {
      return /*#__PURE__*/_react["default"].createElement(_TextField["default"], _extends({}, params, {
        required: required,
        placeholder: value ? "" : placeholder,
        InputLabelProps: {
          shrink: true,
          classes: {
            shrink: classes.labelRoot
          }
        },
        label: label,
        error: !!error,
        helperText: error ? error : helperText ? helperText : null,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 35,
          columnNumber: 30
        }
      }));
    },
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 27,
      columnNumber: 5
    }
  });
}

module.exports = exports.default;